//
//  UIColor+Flat.h
//

/*!
 * Category of flat colors. Uses a lazily allocated dictionary for each color, which is only instantiacized once.
 */
@interface UIColor (Flat)

/*!
 * Turquoise color: #1abc9c
 */
+ (UIColor *)hay_turquoiseColor;

/*!
 * Green sea color: #16a085
 */
+ (UIColor *)hay_greenSeaColor;

/*!
 * Emerald color: #2ecc71
 */
+ (UIColor *)hay_emeraldColor;

/*!
 * Nephritis color: #27ae60
 */
+ (UIColor *)hay_nephritisColor;

/*!
 * Peter River color: #3498db
 */
+ (UIColor *)hay_peterRiverColor;

/*!
 * Belize Hole color: #2980b9
 */
+ (UIColor *)hay_belizeHoleColor;

/*!
 * Amethyst color: #9b59b6
 */
+ (UIColor *)hay_amethystColor;

/*!
 * Wisteria color: #8e44ad
 */
+ (UIColor *)hay_wisteriaColor;

/*!
 * Wet Asphalt color: #34495e
 */
+ (UIColor *)hay_wetAsphaltColor;

/*!
 * Midnight Blue color: #2c3e50
 */
+ (UIColor *)hay_midnightBlueColor;

/*!
 * Sun Flower color: #f1c40f
 */
+ (UIColor *)hay_sunFlowerColor;

/*!
 * Carrot color: #e67e22
 */
+ (UIColor *)hay_carrotColor;

/*!
 * Orange Fruit color: #f39c12
 */
+ (UIColor *)hay_orangeFruitColor;

/*!
 * Pumpkin color: #d35400
 */
+ (UIColor *)hay_pumpkinColor;

/*!
 * Alizarin color: #e74c3c
 */
+ (UIColor *)hay_alizarinColor;

/*!
 * Pomegranate color: #c0392b
 */
+ (UIColor *)hay_pomegranateColor;

/*!
 * Clouds color: #ecf0f1
 */
+ (UIColor *)hay_cloudsColor;

/*!
 * Silver color: #bdc3c7
 */
+ (UIColor *)hay_silverColor;

/*!
 * Concrete color: #95a5a6
 */
+ (UIColor *)hay_concreteColor;

/*!
 * Asbestos color: #7f8c8d
 */
+ (UIColor *)hay_asbestosColor;
@end
